import React, { useState, useEffect, Suspense } from "react";
import { BrowserRouter, Switch, Route } from "react-router-dom"
import './App.css';

function App() {

  const NotFound = React.lazy(() => import('./pages/NotFound'));
  const Contact = React.lazy(() => import('./pages/Contact'));
  const Connexion = React.lazy(() => import('./pages/Connexion'));
  const Login = React.lazy(() => import('./pages/Login'));
  const Recherche_new_v2 = React.lazy(() => import('./pages/recherche_new_v2'));
  const Recherche_new_v3 = React.lazy(() => import('./pages/recherche_new_v3'));
  const Recherche_new_v4 = React.lazy(() => import('./pages/recherche_new_v4'));
  const Mon_Catalogue_Public = React.lazy(() => import('./pages/mon_catalogue_public'));
  const TestUrl = React.lazy(() => import('./pages/testurl'));
  const Account = React.lazy(() => import('./pages/account'));
  const DisplayDetailClass_new_v2 = React.lazy(() => import('./pages/displaydetailclass_new_v2'));
  const DisplayDetailClass_new_v3 = React.lazy(() => import('./pages/displaydetailclass_new_v3'));
  const Display_Partner_Catalog_DetailClass_new_v2 = React.lazy(() => import('./pages/display_partner_catalog_detailclass_new_v2'));
  const DisplayDetailArticle = React.lazy(() => import('./pages/displaydetailarticle'));
  const AddArticleAvis = React.lazy(() => import('./pages/addarticleavis'));
  const Acceuil = React.lazy(() => import('./pages/acceuil'));
  const Partner = React.lazy(() => import('./pages/partner'));
  const CreateAccount = React.lazy(() => import('./pages/createaccount'));
  const PartnerLogin = React.lazy(() => import('./pages/partnerlogin'));
  const PartnerLogin0 = React.lazy(() => import('./pages/partnerlogin0'));
  const PartnerLogin1 = React.lazy(() => import('./pages/partnerlogin1'));
  const RechecheArticles = React.lazy(() => import('./pages/recherchearticles'));
  const AddArticle = React.lazy(() => import('./pages/addarticle'));
  const ResetUserPwd = React.lazy(() => import('./pages/resetuserpwd'));
  const DeleteUserAccount = React.lazy(() => import('./pages/deleteuseraccount'));
  const ContactezNous = React.lazy(() => import('./pages/contactez_nous'));
  const CoupDeCoeur = React.lazy(() => import('./pages/coupdecoeur'));
  const AccountUserActivated = React.lazy(() => import('./pages/accountuseractivated'));
  const ProduitsService = React.lazy(() => import('./pages/produitservice'));
  const Recherche_new = React.lazy(() => import('./pages/recherche_new'));
  const Recherche_old = React.lazy(() => import('./pages/recherche'));
  const UserSignFirst = React.lazy(() => import('./pages/usersigninfirst'));
  const GestionAdministrative = React.lazy(() => import('./components/GestionAdministrative'));
  const Emargement = React.lazy(() => import('./pages/emargementOk'));
  const Formation_Cartouche_Com = React.lazy(() => import('./pages/recherche_cartouche_com'));
  const SeDesabonner = React.lazy(() => import('./pages/sedesabonner'));
  const OrderConfirmation_3DS = React.lazy(() => import('./pages/orderconfirmation_3DS'));
  const Training_Inactive_Or_Not_Found = React.lazy(() => import('./pages/Traning_Inactif_Or_Not_Exist'));
  const Test_Drag_Drop = React.lazy(() => import('./pages/test_drag_drop'));
  const Test_Drag_Drop2 = React.lazy(() => import('./pages/test_dnd'));
  const TestUrl_New = React.lazy(() => import('./pages/testurl_new'));
  const QuiSommesNous_v3 = React.lazy(() => import('./pages/quisommesnous_v3'));
  const Fonctionnalites = React.lazy(() => import('./pages/fonctionnalite'));
  const ESign = React.lazy(() => import('./pages/eSigne'));
  const ESignDiplayDignedDocument = React.lazy(() => import('./pages/edigndiplaydigneddocument'));
  const SurveyDocument = React.lazy(() => import('./pages/surveydocument'));
  const UpdateAttendeeList = React.lazy(() => import('./pages/updateattendeelist'));
  const Emarge_QR_Code = React.lazy(() => import('./pages/emarge_qr_code'));
  const AutomaticQuotation = React.lazy(() => import('./pages/automaticquotation'));
  const MySyIA = React.lazy(() => import('./pages/iamysy'));
  const Maintenance = React.lazy(() => import('./pages/maintenance_page'));
  const Subdomain_Recherche_new_v2 = React.lazy(() => import('./pages/subdomain_recherche_new_v2'));


  const [screenSizeh, getDimension] = useState({
    dynamicWidth: window.innerHeight
  });


  const getSubdomain = url => {
    let domain = url;
    if (url.includes("://")) {
      domain = url.split('://')[1];
    }
    const subdomain = domain.split('.')[0];
    return subdomain;
  };


  useEffect(() => {

    let myurl = window.location.host;
    let myurl_pathname = window.location.pathname;

    //console.log(" url 12 = ", myurl);

    //console.log(" action 12 = ", window.location.pathname);

    var domain = myurl;
    if (domain.includes('://')) {
      domain = myurl.split('://')[1];
    }

    var tab_split = domain.split('.');

    const subdomain = domain.split('.')[0];

    var tab_reserved_subdomain = ['/dev', '/demo', 'demo', 'dev'];

    if (tab_split.length > 1 && myurl_pathname && !tab_reserved_subdomain.includes(subdomain)) {

      var tab_myurl_pathname = myurl_pathname.split('/');

      var tab_action = ['/moncatalog', '/Display-Partner-Catalog-Detail-formation', 'Display-Partner-Catalog-Detail-formation', 'moncatalog'];



      if (tab_myurl_pathname.length > 0 && !tab_action.includes(tab_myurl_pathname[1]) && !tab_reserved_subdomain.includes(subdomain)) {

        var new_url = window.location.protocol + "//" + domain.split('.')[0] + "." + domain.split('.')[1] + "/moncatalog";


        /*
        window.open(
          new_url,
          '_self'
        );
        */

      }


    }


  }, []);


  return (
    <div>
      <div className="App">
        {/*API DEV = {process.env.REACT_APP_API_URL_DEV} <br/>
    API REC = {process.env.REACT_APP_API_URL_REC}<br/>
    API URL = {process.env.REACT_APP_API_URL}<br/>
  */}


        <div className="main_haut">
          <React.Suspense fallback={<p>Loading...</p>}>
            <BrowserRouter>
              <scrollToTop />
              <Switch>
              <Route path="/v3" render={() => <Recherche_new_v3 />} />
                <Route path="/v4" render={() => <Recherche_new_v4 />} />
                <Route path="/subdomain" render={() => <Subdomain_Recherche_new_v2 />} />
                <Route path="/moncatalog" render={() => <Mon_Catalogue_Public />} />
                <Route path="/acceuil" render={() => <Acceuil />} />
                <Route path="/maintenance" render={() => <Maintenance />} />
                <Route path="/markeplace" render={() => <Contact />} />
                <Route path="/contact" render={() => <Contact />} />
                <Route path="/mysy-user-account" render={() => <Account />} />
                <Route path="/create_account" render={() => <CreateAccount />} />
                <Route path="/user-connexion" render={() => <Connexion />} />
                <Route path="/Connexion" render={() => <Login />} />
                <Route path="/recherche-formation" render={() => <Recherche_new_v2 />} />
                <Route path="/recherche-formation/ref/:NewSearchText" render={() => <Recherche_new_v2 />} />
                <Route path="/testurl/:course/:tab" render={() => <TestUrl />} />

                <Route path="/testurl_new/:courseid/:tabid" render={() => <TestUrl_New />} />
                <Route path="/fonctionnalites" render={() => <Fonctionnalites />} />
                <Route path="/QuiSommesNous" render={() => <QuiSommesNous_v3 />} />
                <Route path="/qui-sommes-nous" render={() => <QuiSommesNous_v3 />} />
                <Route path="/QuiSommesNous_v3" render={() => <QuiSommesNous_v3 />} />
                <Route path="/" render={() => <QuiSommesNous_v3 />} />
                <Route path="/ajout-article" render={() => <AddArticleAvis />} />
                <Route path="/Display-Detail-formation_v3/:classId" render={() => <DisplayDetailClass_new_v3 />} />
                <Route path="/Display-Detail-formation/:classId" render={() => <DisplayDetailClass_new_v3 />} />
                <Route path="/Display-Detail-formation/:classId/:action" render={() => <DisplayDetailClass_new_v3 />} />
                <Route path="/Display-Detail-formation_old/:classId/:action" render={() => <DisplayDetailClass_new_v3 />} />
                <Route path="/Display-Detail-Article/:articleId" render={() => <DisplayDetailArticle />} />
                <Route path="/Display-Detail-formation-Coeur/:classId" render={() => <CoupDeCoeur />} />
                <Route path="/Partner/:action/:orderid/:packs" render={() => <Partner />} />
                <Route path="/Display-Partner-Catalog-Detail-formation/:classId" render={() => <Display_Partner_Catalog_DetailClass_new_v2 />} />
                <Route path="/Display-Partner-Catalog-Detail-formation/:classId/:action" render={() => <Display_Partner_Catalog_DetailClass_new_v2 />} />
                <Route path="/Partner/:action/:orderid" render={() => <Partner />} />
                <Route path="/Partner/:action" render={() => <Partner />} />
                <Route path="/Partner" render={() => <Partner />} />
                <Route path="/PartnerLogin" render={() => <PartnerLogin />} />
                <Route path="/PartnerLogin0" render={() => <PartnerLogin0 />} />
                <Route path="/PartnerLogin1" render={() => <PartnerLogin1 />} />
                <Route path="/Recherche-Article-formation" render={() => <RechecheArticles />} />
                <Route path="/Ajout-Article-formation" render={() => <AddArticle />} />
                <Route path="/ResetUserPwd/:token/:accounttype" render={() => <ResetUserPwd />} />
                <Route path="/DeleteUserAccount/:token" render={() => <DeleteUserAccount />} />

                <Route path="/ContactezNous" render={() => <ContactezNous />} />
                <Route path="/mysy-training-login/:obj/:objid" render={() => <Login />} />
                <Route path="/mysy-account-activated/" render={() => <AccountUserActivated />} />
                {/* <Route path="/Produits-Services/" exact component={ProduitsService} />*/}
                <Route path="/tarifs_produits_services/" exact component={ProduitsService} />
                <Route path="/Recherche_new/" exact component={Recherche_new} />
                <Route path="/GestionAdministrative/:internal_url" exact component={GestionAdministrative} />
                <Route path="/Recherche_new/:type/:categorie" exact component={Recherche_new} />
                <Route path="/Recherche_old/" exact component={Recherche_old} />
                <Route path="/Connexion-utilisateur-0/" exact component={UserSignFirst} />
                <Route path="/Emargement/" exact component={Emargement} />
                <Route path="/CartoucheComMySy/" exact component={Formation_Cartouche_Com} />
                <Route path="/Test_DragDrop/" exact component={Test_Drag_Drop} />
                <Route path="/Test_DragDrop2/" exact component={Test_Drag_Drop2} />
                <Route path="/Recherche_new_v2/" exact component={Recherche_new_v2} />
                <Route path="/Recherche_new_v2/:type/:categorie" exact component={Recherche_new_v2} />
                <Route path="/unsubscribe/" exact component={SeDesabonner} />
                <Route path="/OrderConfirmation_3DS/:orderid/:packs" exact component={OrderConfirmation_3DS} />
                <Route path="/page-inconnue/" exact component={NotFound} />
                <Route path="/formation-inconnue/" exact component={Training_Inactive_Or_Not_Found} />

                <Route path="/qr_emargement/:session_id/:partner_owner_recid/:my_safe_token" exact component={Emarge_QR_Code} />

                <Route path="/E_Signature/:document_id" exact component={ESign} />
                <Route path="/E_Document/:document_id/:partner_owner_recid/:secret_key_signature" exact component={ESignDiplayDignedDocument} />

                <Route path="/Survey/:survey_id/" exact component={SurveyDocument} />
                <Route path="/UpadateAttendeeList/:client_id/:session_id/:partner_owner_recid/" exact component={UpdateAttendeeList} />

                <Route path="/automatic-quotation/:partner_owner_recid/:objid/" exact component={AutomaticQuotation} />

                <Route path="/intelligence-artificielle-mysy-training/" exact component={MySyIA} />


                <Route component={NotFound} />
              </Switch>
            </BrowserRouter>
          </React.Suspense>
        </div>

      </div>


    </div>

  );
}


export default App;
